Index: LMDZ6/trunk/libf/phylmd/ecrad/radiation_aerosol_optics.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/ecrad/radiation_aerosol_optics.F90	(revision 4488)
+++ LMDZ6/trunk/libf/phylmd/ecrad/radiation_aerosol_optics.F90	(revision 4489)
@@ -180,8 +892,8 @@
 
       ! Set variables to zero that may not have been previously
-      g_sw = 0.0_jprb
+      g_sw(:,:,istartcol:iendcol) = 0.0_jprb
       if (config%do_lw_aerosol_scattering) then
-        ssa_lw = 0.0_jprb
-        g_lw   = 0.0_jprb
+        ssa_lw(:,:,istartcol:iendcol) = 0.0_jprb
+        g_lw(:,:,istartcol:iendcol)   = 0.0_jprb
       end if
 
@@ -210,4 +922,7 @@
 
           do jtype = 1,config%n_aerosol_types
+
+            itype = ao%itype(jtype)
+
             ! Add the optical depth, scattering optical depth and
             ! scattering optical depth-weighted asymmetry factor for
@@ -216,21 +931,23 @@
             ! dimension being spectral band.
             if (ao%iclass(jtype) == IAerosolClassHydrophobic) then
-              local_od_sw = factor * aerosol%mixing_ratio(jcol,jlev,jtype) &
-                   &  * ao%mass_ext_sw_phobic(:,ao%itype(jtype))
-              od_sw_aerosol = od_sw_aerosol + local_od_sw
-              scat_sw_aerosol = scat_sw_aerosol &
-                   &  + local_od_sw * ao%ssa_sw_phobic(:,ao%itype(jtype))
-              scat_g_sw_aerosol = scat_g_sw_aerosol &
-                   &  + local_od_sw * ao%ssa_sw_phobic(:,ao%itype(jtype)) &
-                   &  * ao%g_sw_phobic(:,ao%itype(jtype))
+              do jband = 1,config%n_bands_sw
+                local_od_sw(jband) = factor * aerosol%mixing_ratio(jcol,jlev,jtype) &
+                     &  * ao%mass_ext_sw_phobic(jband,itype)
+                od_sw_aerosol(jband) = od_sw_aerosol(jband) + local_od_sw(jband)
+                scat_sw_aerosol(jband) = scat_sw_aerosol(jband) &
+                     &  + local_od_sw(jband) * ao%ssa_sw_phobic(jband,itype)
+                scat_g_sw_aerosol(jband) = scat_g_sw_aerosol(jband) &
+                     &  + local_od_sw(jband) * ao%ssa_sw_phobic(jband,itype) &
+                     &  * ao%g_sw_phobic(jband,itype)
+              end do
               if (config%do_lw_aerosol_scattering) then
                 local_od_lw = factor * aerosol%mixing_ratio(jcol,jlev,jtype) &
-                     &  * ao%mass_ext_lw_phobic(:,ao%itype(jtype))
+                     &  * ao%mass_ext_lw_phobic(:,itype)
                 od_lw_aerosol = od_lw_aerosol + local_od_lw
                 scat_lw_aerosol = scat_lw_aerosol &
-                     &  + local_od_lw * ao%ssa_lw_phobic(:,ao%itype(jtype))
+                     &  + local_od_lw * ao%ssa_lw_phobic(:,itype)
                 scat_g_lw_aerosol = scat_g_lw_aerosol &
-                     &  + local_od_lw * ao%ssa_lw_phobic(:,ao%itype(jtype)) &
-                     &  * ao%g_lw_phobic(:,ao%itype(jtype))
+                     &  + local_od_lw * ao%ssa_lw_phobic(:,itype) &
+                     &  * ao%g_lw_phobic(:,itype)
               else
                 ! If aerosol longwave scattering is not included then we
@@ -239,27 +956,29 @@
                 od_lw_aerosol = od_lw_aerosol &
                      &  + factor * aerosol%mixing_ratio(jcol,jlev,jtype) &
-                     &  * ao%mass_ext_lw_phobic(:,ao%itype(jtype)) &
-                     &  * (1.0_jprb - ao%ssa_lw_phobic(:,ao%itype(jtype)))
+                     &  * ao%mass_ext_lw_phobic(:,itype) &
+                     &  * (1.0_jprb - ao%ssa_lw_phobic(:,itype))
               end if
             else if (ao%iclass(jtype) == IAerosolClassHydrophilic) then
               ! Hydrophilic aerosols require the look-up tables to
               ! be indexed with irh
-              local_od_sw = factor * aerosol%mixing_ratio(jcol,jlev,jtype) &
-                   &  * ao%mass_ext_sw_philic(:,irh,ao%itype(jtype))
-              od_sw_aerosol = od_sw_aerosol + local_od_sw
-              scat_sw_aerosol = scat_sw_aerosol &
-                   &  + local_od_sw * ao%ssa_sw_philic(:,irh,ao%itype(jtype))
-              scat_g_sw_aerosol = scat_g_sw_aerosol &
-                   &  + local_od_sw * ao%ssa_sw_philic(:,irh,ao%itype(jtype)) &
-                   &  * ao%g_sw_philic(:,irh,ao%itype(jtype))
+              do jband = 1,config%n_bands_sw
+                local_od_sw(jband) = factor * aerosol%mixing_ratio(jcol,jlev,jtype) &
+                     &  * ao%mass_ext_sw_philic(jband,irh,itype)
+                od_sw_aerosol(jband) = od_sw_aerosol(jband) + local_od_sw(jband)
+                scat_sw_aerosol(jband) = scat_sw_aerosol(jband) &
+                     &  + local_od_sw(jband) * ao%ssa_sw_philic(jband,irh,itype)
+                scat_g_sw_aerosol(jband) = scat_g_sw_aerosol(jband) &
+                     &  + local_od_sw(jband) * ao%ssa_sw_philic(jband,irh,itype) &
+                     &  * ao%g_sw_philic(jband,irh,itype)
+              end do
               if (config%do_lw_aerosol_scattering) then
                 local_od_lw = factor * aerosol%mixing_ratio(jcol,jlev,jtype) &
-                     &  * ao%mass_ext_lw_philic(:,irh,ao%itype(jtype))
+                     &  * ao%mass_ext_lw_philic(:,irh,itype)
                 od_lw_aerosol = od_lw_aerosol + local_od_lw
                 scat_lw_aerosol = scat_lw_aerosol &
-                     &  + local_od_lw * ao%ssa_lw_philic(:,irh,ao%itype(jtype))
+                     &  + local_od_lw * ao%ssa_lw_philic(:,irh,itype)
                 scat_g_lw_aerosol = scat_g_lw_aerosol &
-                     &  + local_od_lw * ao%ssa_lw_philic(:,irh,ao%itype(jtype)) &
-                     &  * ao%g_lw_philic(:,irh,ao%itype(jtype))
+                     &  + local_od_lw * ao%ssa_lw_philic(:,irh,itype) &
+                     &  * ao%g_lw_philic(:,irh,itype)
               else
                 ! If aerosol longwave scattering is not included then we
@@ -268,6 +987,6 @@
                 od_lw_aerosol = od_lw_aerosol &
                      &  + factor * aerosol%mixing_ratio(jcol,jlev,jtype) &
-                     &  * ao%mass_ext_lw_philic(:,irh,ao%itype(jtype)) &
-                     &  * (1.0_jprb - ao%ssa_lw_philic(:,irh,ao%itype(jtype)))
+                     &  * ao%mass_ext_lw_philic(:,irh,itype) &
+                     &  * (1.0_jprb - ao%ssa_lw_philic(:,irh,itype))
               end if
             end if
@@ -289,8 +1008,8 @@
           ! properties (noting that any gas scattering will have an
           ! asymmetry factor of zero)
-          if (od_sw_aerosol(1) > 0.0_jprb) then
-            do jg = 1,config%n_g_sw
-              iband = config%i_band_from_reordered_g_sw(jg)
-              local_od = od_sw(jg,jlev,jcol) + od_sw_aerosol(iband)
+          do jg = 1,config%n_g_sw
+            iband = config%i_band_from_reordered_g_sw(jg)
+            local_od = od_sw(jg,jlev,jcol) + od_sw_aerosol(iband)
+            if (local_od > 0.0_jprb .and. od_sw_aerosol(iband) > 0.0_jprb) then
               local_scat = ssa_sw(jg,jlev,jcol) * od_sw(jg,jlev,jcol) &
                    &  + scat_sw_aerosol(iband)
@@ -298,9 +1017,11 @@
               ! simply weights the aerosol asymmetry by the scattering
               ! optical depth
-              g_sw(jg,jlev,jcol) = scat_g_sw_aerosol(iband) / local_scat
+              if (local_scat > 0.0_jprb) then
+                g_sw(jg,jlev,jcol) = scat_g_sw_aerosol(iband) / local_scat
+              end if
               ssa_sw(jg,jlev,jcol) = local_scat / local_od
               od_sw (jg,jlev,jcol) = local_od
-            end do
-          end if
+            end if
+          end do
 
           ! Combine aerosol longwave scattering properties with gas
@@ -314,5 +1035,6 @@
             do jg = 1,config%n_g_lw
               iband = config%i_band_from_reordered_g_lw(jg)
-              if (od_lw_aerosol(iband) > 0.0_jprb) then
+              local_od = od_lw(jg,jlev,jcol) + od_lw_aerosol(iband)
+              if (local_od > 0.0_jprb .and. od_lw_aerosol(iband) > 0.0_jprb) then
                 ! All scattering is due to aerosols, therefore the
                 ! asymmetry factor is equal to the value for aerosols
@@ -320,8 +1042,5 @@
                   g_lw(jg,jlev,jcol) = scat_g_lw_aerosol(iband) &
                        &  / scat_lw_aerosol(iband)
-                else
-                  g_lw(jg,jlev,jcol) = 0.0_jprb
                 end if
-                local_od = od_lw(jg,jlev,jcol) + od_lw_aerosol(iband)
                 ssa_lw(jg,jlev,jcol) = scat_lw_aerosol(iband) / local_od
                 od_lw (jg,jlev,jcol) = local_od
@@ -384,12 +1103,12 @@
     ! a point in space for each spectral band of the shortwave and
     ! longwave spectrum
-    real(jprb), dimension(config%n_bands_sw) &
+    real(jprb), dimension(config%n_bands_sw,nlev) &
          & :: od_sw_aerosol, scat_sw_aerosol, scat_g_sw_aerosol
-    real(jprb), dimension(config%n_bands_lw) :: od_lw_aerosol
-    real(jprb), dimension(config%n_bands_lw_if_scattering) &
+    real(jprb), dimension(config%n_bands_lw,nlev) :: od_lw_aerosol
+    real(jprb), dimension(config%n_bands_lw_if_scattering,nlev) &
          & :: scat_lw_aerosol, scat_g_lw_aerosol
 
     ! Loop indices for column, level, g point and band
-    integer :: jcol, jlev, jg
+    integer :: jcol, jlev, jg, jb
 
     ! Range of levels over which aerosols are present
@@ -416,35 +1135,41 @@
 
       ! Set variables to zero that may not have been previously
-      g_sw = 0.0_jprb
+      g_sw(:,:,istartcol:iendcol) = 0.0_jprb
 
       ! Loop over position
       do jcol = istartcol,iendcol
+! Added for DWD (2020)
+!NEC$ forced_collapse
         do jlev = istartlev,iendlev
-          od_sw_aerosol = aerosol%od_sw(:,jlev,jcol)
-          scat_sw_aerosol = aerosol%ssa_sw(:,jlev,jcol) * od_sw_aerosol
-          scat_g_sw_aerosol = aerosol%g_sw(:,jlev,jcol) * scat_sw_aerosol
-
-          if (.not. config%do_sw_delta_scaling_with_gases) then
-            ! Delta-Eddington scaling on aerosol only.  Note that if
-            ! do_sw_delta_scaling_with_gases==.true. then the delta
-            ! scaling is done to the cloud-aerosol-gas mixture inside
-            ! the solver
-            call delta_eddington_extensive(od_sw_aerosol, scat_sw_aerosol, &
-                 &                         scat_g_sw_aerosol)
-          end if
-
-          ! Combine aerosol shortwave scattering properties with gas
-          ! properties (noting that any gas scattering will have an
-          ! asymmetry factor of zero)
-          if (od_sw_aerosol(1) > 0.0_jprb) then
+          do jb = 1,config%n_bands_sw
+            od_sw_aerosol(jb,jlev) = aerosol%od_sw(jb,jlev,jcol)
+            scat_sw_aerosol(jb,jlev) = aerosol%ssa_sw(jb,jlev,jcol) * od_sw_aerosol(jb,jlev)
+            scat_g_sw_aerosol(jb,jlev) = aerosol%g_sw(jb,jlev,jcol) * scat_sw_aerosol(jb,jlev)
+
+            if (.not. config%do_sw_delta_scaling_with_gases) then
+              ! Delta-Eddington scaling on aerosol only.  Note that if
+              ! do_sw_delta_scaling_with_gases==.true. then the delta
+              ! scaling is done to the cloud-aerosol-gas mixture
+              ! inside the solver
+              call delta_eddington_extensive(od_sw_aerosol(jb,jlev), scat_sw_aerosol(jb,jlev), &
+                   &                         scat_g_sw_aerosol(jb,jlev))
+            end if
+          end do
+        end do
+        ! Combine aerosol shortwave scattering properties with gas
+        ! properties (noting that any gas scattering will have an
+        ! asymmetry factor of zero)
+        do jlev = istartlev,iendlev
+          if (od_sw_aerosol(1,jlev) > 0.0_jprb) then
             do jg = 1,config%n_g_sw
               iband = config%i_band_from_reordered_g_sw(jg)
-              local_od = od_sw(jg,jlev,jcol) + od_sw_aerosol(iband)
+              local_od = od_sw(jg,jlev,jcol) + od_sw_aerosol(iband,jlev)
               local_scat = ssa_sw(jg,jlev,jcol) * od_sw(jg,jlev,jcol) &
-                   &  + scat_sw_aerosol(iband)
+                   &  + scat_sw_aerosol(iband,jlev)
               ! Note that asymmetry_sw of gases is zero so the following
               ! simply weights the aerosol asymmetry by the scattering
               ! optical depth
-              g_sw(jg,jlev,jcol) = scat_g_sw_aerosol(iband) / local_scat
+              g_sw(jg,jlev,jcol) = scat_g_sw_aerosol(iband,jlev) / local_scat
+              local_od = od_sw(jg,jlev,jcol) + od_sw_aerosol(iband,jlev)
               ssa_sw(jg,jlev,jcol) = local_scat / local_od
               od_sw (jg,jlev,jcol) = local_od
@@ -469,30 +1194,33 @@
 
       if (config%do_lw_aerosol_scattering) then
-        ssa_lw = 0.0_jprb
-        g_lw   = 0.0_jprb
+        ssa_lw(:,:,istartcol:iendcol) = 0.0_jprb
+        g_lw(:,:,istartcol:iendcol)   = 0.0_jprb
  
         ! Loop over position
         do jcol = istartcol,iendcol
+! Added for DWD (2020)
+!NEC$ forced_collapse
           do jlev = istartlev,iendlev
-            od_lw_aerosol = aerosol%od_lw(:,jlev,jcol)
-            scat_lw_aerosol = aerosol%ssa_lw(:,jlev,jcol) * od_lw_aerosol
-            scat_g_lw_aerosol = aerosol%g_lw(:,jlev,jcol) * scat_lw_aerosol
+            do jb = 1,config%n_bands_lw
+              od_lw_aerosol(jb,jlev) = aerosol%od_lw(jb,jlev,jcol)
+              scat_lw_aerosol(jb,jlev) = aerosol%ssa_lw(jb,jlev,jcol) * od_lw_aerosol(jb,jlev)
+              scat_g_lw_aerosol(jb,jlev) = aerosol%g_lw(jb,jlev,jcol) * scat_lw_aerosol(jb,jlev)
             
-            call delta_eddington_extensive(od_lw_aerosol, scat_lw_aerosol, &
-                 &                         scat_g_lw_aerosol)
-            
+              call delta_eddington_extensive(od_lw_aerosol(jb,jlev), scat_lw_aerosol(jb,jlev), &
+                   &                         scat_g_lw_aerosol(jb,jlev))
+            end do
+          end do
+          do jlev = istartlev,iendlev
             do jg = 1,config%n_g_lw
               iband = config%i_band_from_reordered_g_lw(jg)
-              if (od_lw_aerosol(iband) > 0.0_jprb) then
+              if (od_lw_aerosol(iband,jlev) > 0.0_jprb) then
                 ! All scattering is due to aerosols, therefore the
                 ! asymmetry factor is equal to the value for aerosols
-                if (scat_lw_aerosol(iband) > 0.0_jprb) then
-                  g_lw(jg,jlev,jcol) = scat_g_lw_aerosol(iband) &
-                       &  / scat_lw_aerosol(iband)
-                else
-                  g_lw(jg,jlev,jcol) = 0.0_jprb
+                if (scat_lw_aerosol(iband,jlev) > 0.0_jprb) then
+                  g_lw(jg,jlev,jcol) = scat_g_lw_aerosol(iband,jlev) &
+                       &  / scat_lw_aerosol(iband,jlev)
                 end if
-                local_od = od_lw(jg,jlev,jcol) + od_lw_aerosol(iband)
-                ssa_lw(jg,jlev,jcol) = scat_lw_aerosol(iband) / local_od
+                local_od = od_lw(jg,jlev,jcol) + od_lw_aerosol(iband,jlev)
+                ssa_lw(jg,jlev,jcol) = scat_lw_aerosol(iband,jlev) / local_od
                 od_lw (jg,jlev,jcol) = local_od
               end if
@@ -505,13 +1233,19 @@
         ! Loop over position
         do jcol = istartcol,iendcol
+! Added for DWD (2020)
+!NEC$ forced_collapse
           do jlev = istartlev,iendlev
             ! If aerosol longwave scattering is not included then we
             ! weight the optical depth by the single scattering
             ! co-albedo
-            od_lw_aerosol = aerosol%od_lw(:,jlev,jcol) &
-                 &  * (1.0_jprb - aerosol%ssa_lw(:,jlev,jcol))
+            do jb = 1, config%n_bands_lw
+              od_lw_aerosol(jb,jlev) = aerosol%od_lw(jb,jlev,jcol) &
+                 &  * (1.0_jprb - aerosol%ssa_lw(jb,jlev,jcol))
+            end do
+          end do
+          do jlev = istartlev,iendlev
             do jg = 1,config%n_g_lw
               od_lw(jg,jlev,jcol) = od_lw(jg,jlev,jcol) &
-                   &  + od_lw_aerosol(config%i_band_from_reordered_g_lw(jg))
+                   &  + od_lw_aerosol(config%i_band_from_reordered_g_lw(jg),jlev)
             end do
           end do
@@ -530,11 +1264,12 @@
   ! Sometimes it is useful to specify aerosol in terms of its optical
   ! depth at a particular wavelength.  This function returns the dry
-  ! shortwave mass-extinction coefficient, i.e. the extinction cross
-  ! section per unit mass, for aerosol of type "itype" at shortwave
-  ! band "iband". For hydrophilic types, the value at the first
-  ! relative humidity bin is taken.
-  function dry_aerosol_sw_mass_extinction(config, itype, iband)
+  ! mass-extinction coefficient, i.e. the extinction cross section per
+  ! unit mass, for aerosol of type "itype" at the specified wavelength
+  ! (m). For hydrophilic types, the value at the first relative
+  ! humidity bin is taken.
+  function dry_aerosol_mass_extinction(config, itype, wavelength)
 
     use parkind1,                      only : jprb
+    use radiation_io,                  only : nulerr, radiation_abort
     use radiation_config,              only : config_type
     use radiation_aerosol_optics_data, only : aerosol_optics_type, &
@@ -544,8 +1279,14 @@
     type(config_type), intent(in), target :: config
 
-    ! Aerosol type and shortwave band as indices to the array
-    integer, intent(in) :: itype, iband
+    ! Aerosol type
+    integer, intent(in) :: itype
+
+    ! Wavelength (m)
+    real(jprb), intent(in) :: wavelength
     
-    real(jprb) dry_aerosol_sw_mass_extinction
+    real(jprb) :: dry_aerosol_mass_extinction
+
+    ! Index to the monochromatic wavelength requested
+    integer :: imono
 
     ! Pointer to the aerosol optics coefficients for brevity of access
@@ -554,23 +1295,30 @@
     ao => config%aerosol_optics
 
+    imono = minloc(abs(wavelength - ao%wavelength_mono), 1)
+
+    if (abs(wavelength - ao%wavelength_mono(imono))/wavelength > 0.01_jprb) then
+      write(nulerr,'(a,e8.4,a)') '*** Error: requested wavelength ', &
+           &  wavelength, ' not within 1% of stored wavelengths'
+      call radiation_abort()
+     end if
+
     if (ao%iclass(itype) == IAerosolClassHydrophobic) then
-      dry_aerosol_sw_mass_extinction = ao%mass_ext_sw_phobic(iband,ao%itype(itype))
+      dry_aerosol_mass_extinction = ao%mass_ext_mono_phobic(imono,ao%itype(itype))
     else if (ao%iclass(itype) == IAerosolClassHydrophilic) then
       ! Take the value at the first relative-humidity bin for the
       ! "dry" aerosol value
-      dry_aerosol_sw_mass_extinction = ao%mass_ext_sw_philic(iband,1,ao%itype(itype))
+      dry_aerosol_mass_extinction = ao%mass_ext_mono_philic(imono,1,ao%itype(itype))
     else
-      dry_aerosol_sw_mass_extinction = 0.0_jprb
-    end if
-
-  end function dry_aerosol_sw_mass_extinction
+      dry_aerosol_mass_extinction = 0.0_jprb
+    end if
+
+  end function dry_aerosol_mass_extinction
 
 
   !---------------------------------------------------------------------
-  ! Compute aerosol extinction coefficient at a particular shortwave
-  ! band and a single height - this is useful for visibility
-  ! diagnostics
-  subroutine aerosol_sw_extinction(ncol,istartcol,iendcol, &
-       &  config, iband, mixing_ratio, relative_humidity, extinction)
+  ! Compute aerosol extinction coefficient at a particular wavelength
+  ! and a single height - this is useful for visibility diagnostics
+  subroutine aerosol_extinction(ncol,istartcol,iendcol, &
+       &  config, wavelength, mixing_ratio, relative_humidity, extinction)
 
     use parkind1,                      only : jprb
@@ -585,5 +1333,5 @@
     integer, intent(in) :: istartcol, iendcol ! range of columns to process
     type(config_type), intent(in), target :: config
-    integer, intent(in)     :: iband ! Index of required spectral band
+    real(jprb), intent(in)  :: wavelength ! Requested wavelength (m)
     real(jprb), intent(in)  :: mixing_ratio(ncol,config%n_aerosol_types)
     real(jprb), intent(in)  :: relative_humidity(ncol)
@@ -592,4 +1340,7 @@
     ! Local aerosol extinction
     real(jprb) :: ext
+
+    ! Index to the monochromatic wavelength requested
+    integer :: imono
 
     ! Pointer to the aerosol optics coefficients for brevity of access
@@ -604,5 +1355,5 @@
     real(jprb) :: hook_handle
 
-    if (lhook) call dr_hook('radiation_aerosol_optics:aerosol_sw_extinction',0,hook_handle)
+    if (lhook) call dr_hook('radiation_aerosol_optics:aerosol_extinction',0,hook_handle)
 
     do jtype = 1,config%n_aerosol_types
@@ -614,4 +1365,12 @@
 
     ao => config%aerosol_optics
+
+    imono = minloc(abs(wavelength - ao%wavelength_mono), 1)
+
+    if (abs(wavelength - ao%wavelength_mono(imono))/wavelength > 0.01_jprb) then
+      write(nulerr,'(a,e8.4,a)') '*** Error: requested wavelength ', &
+           &  wavelength, ' not within 1% of stored wavelengths'
+      call radiation_abort()
+     end if
 
     ! Loop over position
@@ -624,8 +1383,8 @@
         if (ao%iclass(jtype) == IAerosolClassHydrophobic) then
           ext = ext + mixing_ratio(jcol,jtype) &
-               &    * ao%mass_ext_sw_phobic(iband,ao%itype(jtype))
+               &    * ao%mass_ext_mono_phobic(imono,ao%itype(jtype))
         else if (ao%iclass(jtype) == IAerosolClassHydrophilic) then
           ext = ext + mixing_ratio(jcol,jtype) &
-               &    * ao%mass_ext_sw_philic(iband,irh,ao%itype(jtype))
+               &    * ao%mass_ext_mono_philic(imono,irh,ao%itype(jtype))
         end if
       end do
@@ -634,7 +1393,7 @@
     end do
 
-    if (lhook) call dr_hook('radiation_aerosol_optics:aerosol_sw_extinction',1,hook_handle)
-
-  end subroutine aerosol_sw_extinction
+    if (lhook) call dr_hook('radiation_aerosol_optics:aerosol_extinction',1,hook_handle)
+
+  end subroutine aerosol_extinction
 
 end module radiation_aerosol_optics
